/* This file has been generated by the VFPG from tests/regression-tests/full_example.xml */
/* Version v6.0_unstable-none--dirty */
/* Please DO NOT EDIT */

#ifndef FLIGHT_PLAN_H
#define FLIGHT_PLAN_H

#include "std.h"
#include "generated/modules.h"
#include "modules/core/abi.h"
#include "autopilot.h"


    #include "autopilot.h"
    #include "modules/datalink/datalink.h"
    #include "modules/energy/electrical.h"
    #include "modules/radio_control/radio_control.h"

#define FLIGHT_PLAN_NAME "Delft Basic"
#define NAV_DEFAULT_ALT 4 /* nominal altitude of the flight plan */
#define NAV_UTM_EAST0 594640
#define NAV_UTM_NORTH0 5760934
#define NAV_UTM_ZONE0 31
#define NAV_LAT0 519909999 /* 1e7deg */
#define NAV_LON0 43783333 /* 1e7deg */
#define NAV_ALT0 0 /* mm above msl */
#define NAV_MSL0 45110 /* mm, EGM96 geoid-height (msl) over ellipsoid */
#define QFU 0.0
#define WP_dummy 0
#define WP_HOME 1
#define WP_CLIMB 2
#define WP_STDBY 3
#define WP_p1 4
#define WP_p2 5
#define WP_p3 6
#define WP_p4 7
#define WP_CAM 8
#define WP_TD 9
#define WAYPOINTS_UTM { \
 {0.0, 0.0, 4},\
 {0.0, 0.0, 4},\
 {0.0, 5.0, 4},\
 {-2.0, -5.0, 4},\
 {-19.9, 14.3, 4},\
 {-0.6, 21.6, 4},\
 {22.2, -26.5, 4},\
 {4.9, -34.4, 4},\
 {14.2, -29.4, 4},\
 {5.6, -10.9, 4},\
};
#define WAYPOINTS_ENU { \
 {-0.00, -0.00, 4.00}, /* ENU in meters  */ \
 {-0.00, -0.00, 4.00}, /* ENU in meters  */ \
 {0.09, 5.00, 4.00}, /* ENU in meters  */ \
 {-2.10, -4.96, 4.00}, /* ENU in meters  */ \
 {-19.63, 14.68, 4.00}, /* ENU in meters  */ \
 {-0.19, 21.61, 4.00}, /* ENU in meters  */ \
 {21.70, -26.92, 4.00}, /* ENU in meters  */ \
 {4.25, -34.50, 4.00}, /* ENU in meters  */ \
 {13.64, -29.67, 4.00}, /* ENU in meters  */ \
 {5.39, -11.01, 4.00}, /* ENU in meters  */ \
};
#define WAYPOINTS_LLA { \
 {.lat=519909999, .lon=43783333, .alt=4000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=45.11m) */ \
 {.lat=519909999, .lon=43783333, .alt=4000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=45.11m) */ \
 {.lat=519910449, .lon=43783347, .alt=4000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=45.11m) */ \
 {.lat=519909553, .lon=43783028, .alt=4000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=45.11m) */ \
 {.lat=519911319, .lon=43780475, .alt=4000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=45.11m) */ \
 {.lat=519911942, .lon=43783305, .alt=4000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=45.11m) */ \
 {.lat=519907580, .lon=43786492, .alt=4000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=45.11m) */ \
 {.lat=519906899, .lon=43783951, .alt=4000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=45.11m) */ \
 {.lat=519907333, .lon=43785319, .alt=4000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=45.11m) */ \
 {.lat=519909010, .lon=43784118, .alt=4000}, /* 1e7deg, 1e7deg, mm (above NAV_MSL0, local msl=45.11m) */ \
};
#define WAYPOINTS_LLA_WGS84 { \
 {.lat=519909999, .lon=43783333, .alt=49110}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=519909999, .lon=43783333, .alt=49110}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=519910449, .lon=43783347, .alt=49110}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=519909553, .lon=43783028, .alt=49110}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=519911319, .lon=43780475, .alt=49110}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=519911942, .lon=43783305, .alt=49110}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=519907580, .lon=43786492, .alt=49110}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=519906899, .lon=43783951, .alt=49110}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=519907333, .lon=43785319, .alt=49110}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
 {.lat=519909010, .lon=43784118, .alt=49110}, /* 1e7deg, 1e7deg, mm (above WGS84 ref ellipsoid) */ \
};
#define WAYPOINTS_GLOBAL { \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
 FALSE, \
};
#define NB_WAYPOINT 10
#define FP_BLOCKS { \
 "INIT_BLOCK" , \
 "Wait GPS" , \
 "Geo init" , \
 "Holding point" , \
 "Start Engine" , \
 "Takeoff" , \
 "Standby" , \
 "stay_p1" , \
 "go_p2" , \
 "line_p1_p2" , \
 "route" , \
 "test yaw" , \
 "circle CAM" , \
 "land here" , \
 "land" , \
 "flare" , \
 "landed" , \
 "ComeBackAndLand" , \
 "DatalinkLoss" , \
 "HOME" , \
}
#define NB_BLOCKS 20
#define GROUND_ALT 0.
#define GROUND_ALT_CM 0
#define SECURITY_HEIGHT 2.
#define SECURITY_ALT 2.
#define HOME_MODE_HEIGHT 2.
#define MAX_DIST_FROM_HOME 1000.


#ifndef FBW


#endif

#ifdef NAV_C


static inline void auto_nav_init(void) {
}

int _var_i_1;

int _var_i_1_to;

unsigned char const nb_blocks = 20;

void on_enter_block(unsigned char block)
{
  switch (block) {
    default:
      break;
    
  }
}

void on_exit_block(unsigned char block)
{
  switch (block) {
    default:
      break;
    
  }
}

_Bool forbidden_deroute(unsigned char from, unsigned char to)
{
  switch (from) {
    default:
      break;
    
  }
  return (_Bool) 0;
}

static inline void auto_nav(void)
{
  unsigned char tmp_nav_block;
  unsigned char tmp_nav_stage;
  _Bool tmp_cond;
  float tmp_RadOfDeg;
  float tmp_AltitudeMode;
  _Bool tmp_NavCond;
  tmp_nav_block = get_nav_block();
  if (tmp_nav_block != 17) {
    tmp_cond =
      (_Bool) ((((radio_control.status==RC_REALLY_LOST)&&!((5>nav_block)))&&!((nav_block>=13)))&&(autopilot_in_flight()==true));
  } else {
    tmp_cond = (_Bool) 0;
  }
  if (tmp_cond) {
    nav_goto_block(17);
    return;
  }
  tmp_nav_block = get_nav_block();
  if (tmp_nav_block != 18) {
    tmp_cond =
      (_Bool) (((((datalink_time>60)&&!((datalink_time>120)))&&!((5>nav_block)))&&!((nav_block>=13)))&&(autopilot_in_flight()==true));
  } else {
    tmp_cond = (_Bool) 0;
  }
  if (tmp_cond) {
    nav_goto_block(18);
    return;
  }
  tmp_nav_block = get_nav_block();
  if (tmp_nav_block != 17) {
    tmp_cond =
      (_Bool) (((electrical.bat_low&&!((3>nav_block)))&&!((nav_block>=13)))&&(autopilot_in_flight()==true));
  } else {
    tmp_cond = (_Bool) 0;
  }
  if (tmp_cond) {
    nav_goto_block(17);
    return;
  }
  tmp_nav_block = get_nav_block();
  if (tmp_nav_block != 13) {
    tmp_cond =
      (_Bool) (((electrical.bat_critical&&!((3>nav_block)))&&!((nav_block>=13)))&&(autopilot_in_flight()==true));
  } else {
    tmp_cond = (_Bool) 0;
  }
  if (tmp_cond) {
    nav_goto_block(13);
    return;
  }
  tmp_nav_block = get_nav_block();
  switch (tmp_nav_block) {
    case 0:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        default:
          set_nav_stage(0);
          NextBlock();
          break;
        
      }
      break;
    case 1:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          NavKillThrottle();
          NextStage();
        case 1:
          while_1_1:
          set_nav_stage(1);
          if (!(!(GpsFixValid()))) {
            goto endwhile_1_2;
          } else {
            NextStage();
            break;
          }
        case 2:
          set_nav_stage(2);
          goto while_1_1;
          endwhile_1_2:
          set_nav_stage(3);
        default:
          set_nav_stage(3);
          NextBlock();
          break;
        
      }
      break;
    case 2:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          while_2_0:
          set_nav_stage(0);
          if (!(LessThan(NavBlockTime(),10))) {
            goto endwhile_2_1;
          } else {
            NextStage();
            break;
          }
        case 1:
          set_nav_stage(1);
          goto while_2_0;
          endwhile_2_1:
          set_nav_stage(2);
        case 2:
          set_nav_stage(2);
          NavSetGroundReferenceHere();
          NextStage();
        default:
          set_nav_stage(3);
          NextBlock();
          break;
        
      }
      break;
    case 3:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          NavKillThrottle();
          NextStage();
        case 1:
          set_nav_stage(1);
          tmp_RadOfDeg = RadOfDeg(0);
          NavAttitude(tmp_RadOfDeg);
          tmp_RadOfDeg = RadOfDeg(0);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          NavVerticalThrottleMode(0 * 9600);
          if (FALSE) {
            NextStage();
            break;
          }
          break;
        default:
          set_nav_stage(2);
          NextBlock();
          break;
        
      }
      break;
    case 4:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          NavResurrect();
          NextStage();
        case 1:
          set_nav_stage(1);
          tmp_RadOfDeg = RadOfDeg(0);
          NavAttitude(tmp_RadOfDeg);
          tmp_RadOfDeg = RadOfDeg(0);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          NavVerticalThrottleMode(0 * 9600);
          if (FALSE) {
            NextStage();
            break;
          }
          break;
        default:
          set_nav_stage(2);
          NextBlock();
          break;
        
      }
      break;
    case 5:
      tmp_nav_block = get_nav_block();
      if (tmp_nav_block != 6) {
        tmp_cond = (_Bool) (GetPosHeight()>2.000000);
      } else {
        tmp_cond = (_Bool) 0;
      }
      if (tmp_cond) {
        nav_goto_block(6);
        return;
      }
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          NavSetWaypointHere(WP_CLIMB);
          NextStage();
        case 1:
          set_nav_stage(1);
          NavGotoWaypoint(2);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          NavVerticalClimbMode(nav_climb_vspeed);
          break;
        default:
          set_nav_stage(2);
          NextBlock();
          break;
        
      }
      break;
    case 6:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          NavGotoWaypoint(3);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          tmp_AltitudeMode = WaypointAlt(3);
          NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          break;
        default:
          set_nav_stage(1);
          NextBlock();
          break;
        
      }
      break;
    case 7:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          NavGotoWaypoint(4);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          tmp_AltitudeMode = WaypointAlt(4);
          NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          break;
        default:
          set_nav_stage(1);
          NextBlock();
          break;
        
      }
      break;
    case 8:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          tmp_NavCond = NavApproaching(5, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(5);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            tmp_AltitudeMode = WaypointAlt(5);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 1:
          set_nav_stage(1);
          NextStage();
          nav_goto_block(7);
          break;
        default:
          set_nav_stage(2);
          NextBlock();
          break;
        
      }
      break;
    case 9:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            tmp_AltitudeMode = WaypointAlt(5);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 1:
          set_nav_stage(1);
          NavGotoWaypoint(5);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          tmp_AltitudeMode = WaypointAlt(5);
          NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          if ((stage_time>10)) {
            NextStage();
            break;
          }
          break;
        case 2:
          set_nav_stage(2);
          tmp_NavCond = NavApproachingFrom(4, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(5, 4);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            tmp_AltitudeMode = WaypointAlt(4);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 3:
          set_nav_stage(3);
          NextStage();
          nav_goto_block(7);
          break;
        default:
          set_nav_stage(4);
          NextBlock();
          break;
        
      }
      break;
    case 10:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          tmp_NavCond = NavApproachingFrom(5, 4, CARROT);
          if (tmp_NavCond) {
            last_wp = 5;
            NextStage();
            break;
          } else {
            NavSegment(4, 5);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            tmp_AltitudeMode = WaypointAlt(5);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 1:
          set_nav_stage(1);
          tmp_NavCond = NavApproachingFrom(6, 5, CARROT);
          if (tmp_NavCond) {
            last_wp = 6;
            NextStage();
            break;
          } else {
            NavSegment(5, 6);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            tmp_AltitudeMode = WaypointAlt(6);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 2:
          set_nav_stage(2);
          tmp_NavCond = NavApproachingFrom(7, 6, CARROT);
          if (tmp_NavCond) {
            last_wp = 7;
            NextStage();
            break;
          } else {
            NavSegment(6, 7);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            tmp_AltitudeMode = WaypointAlt(7);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 3:
          set_nav_stage(3);
          tmp_NavCond = NavApproachingFrom(4, 7, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavSegment(7, 4);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            tmp_AltitudeMode = WaypointAlt(4);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 4:
          set_nav_stage(4);
          NextStage();
          nav_goto_block(7);
          break;
        default:
          set_nav_stage(5);
          NextBlock();
          break;
        
      }
      break;
    case 11:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          tmp_NavCond = NavApproaching(4, CARROT);
          if (tmp_NavCond) {
            last_wp = 4;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(4);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            tmp_AltitudeMode = WaypointAlt(4);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 1:
          set_nav_stage(1);
          _var_i_1 = 1;
          NextStage();
        case 2:
          set_nav_stage(2);
          _var_i_1_to = 16;
          NextStage();
        case 3:
          while_11_3:
          set_nav_stage(3);
          if (!(_var_i_1 <= _var_i_1_to)) {
            goto endwhile_11_6;
          } else {
            NextStage();
            break;
          }
        case 4:
          set_nav_stage(4);
          tmp_RadOfDeg = RadOfDeg((90*_var_i_1));
          NavHeading(tmp_RadOfDeg);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          NavVerticalAltitudeMode(WaypointAlt(WP_p1), 0);
          if ((stage_time>3)) {
            NextStage();
            break;
          }
          break;
        case 5:
          set_nav_stage(5);
          _var_i_1 = _var_i_1 + 1;
          NextStage();
        case 6:
          set_nav_stage(6);
          goto while_11_3;
          endwhile_11_6:
          set_nav_stage(7);
        case 7:
          set_nav_stage(7);
          NextStage();
          nav_goto_block(6);
          break;
        default:
          set_nav_stage(8);
          NextBlock();
          break;
        
      }
      break;
    case 12:
      (nav_set_heading_towards_waypoint(WP_CAM));
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          tmp_AltitudeMode = WaypointAlt(8);
          NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          NavCircleWaypoint(8, nav_radius);
          break;
        default:
          set_nav_stage(1);
          NextBlock();
          break;
        
      }
      break;
    case 13:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          NavSetWaypointHere(WP_TD);
          NextStage();
        default:
          set_nav_stage(1);
          NextBlock();
          break;
        
      }
      break;
    case 14:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          tmp_NavCond = NavApproaching(9, CARROT);
          if (tmp_NavCond) {
            last_wp = 9;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(9);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            tmp_AltitudeMode = WaypointAlt(9);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        default:
          set_nav_stage(1);
          NextBlock();
          break;
        
      }
      break;
    case 15:
      tmp_nav_block = get_nav_block();
      if (tmp_nav_block != 3) {
        tmp_cond = (_Bool) NavDetectGround();
      } else {
        tmp_cond = (_Bool) 0;
      }
      if (tmp_cond) {
        nav_goto_block(3);
        return;
      }
      tmp_nav_block = get_nav_block();
      if (tmp_nav_block != 16) {
        tmp_cond = (_Bool) !(nav_is_in_flight());
      } else {
        tmp_cond = (_Bool) 0;
      }
      if (tmp_cond) {
        nav_goto_block(16);
        return;
      }
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          NavStartDetectGround();
          NextStage();
        case 1:
          set_nav_stage(1);
          NavGotoWaypoint(9);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          NavVerticalClimbMode(nav_descend_vspeed);
          break;
        default:
          set_nav_stage(2);
          NextBlock();
          break;
        
      }
      break;
    case 16:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          tmp_RadOfDeg = RadOfDeg(0);
          NavAttitude(tmp_RadOfDeg);
          tmp_RadOfDeg = RadOfDeg(0);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          NavVerticalThrottleMode(0 * 9600);
          if (FALSE) {
            NextStage();
            break;
          }
          break;
        default:
          set_nav_stage(1);
          NextBlock();
          break;
        
      }
      break;
    case 17:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          tmp_NavCond = NavApproaching(1, CARROT);
          if (tmp_NavCond) {
            last_wp = 1;
            NextStage();
            break;
          } else {
            NavGotoWaypoint(1);
            tmp_RadOfDeg = RadOfDeg(0.000000);
            NavVerticalAutoThrottleMode(tmp_RadOfDeg);
            tmp_AltitudeMode = WaypointAlt(1);
            NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          }
          break;
        case 1:
          set_nav_stage(1);
          NextStage();
          nav_goto_block(13);
          break;
        default:
          set_nav_stage(2);
          NextBlock();
          break;
        
      }
      break;
    case 18:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          NavSetWaypointHere(WP_TD);
          NextStage();
        case 1:
          set_nav_stage(1);
          NavGotoWaypoint(9);
          tmp_RadOfDeg = RadOfDeg(0.000000);
          NavVerticalAutoThrottleMode(tmp_RadOfDeg);
          tmp_AltitudeMode = WaypointAlt(9);
          NavVerticalAltitudeMode(tmp_AltitudeMode, 0);
          if ((stage_time>60)) {
            NextStage();
            break;
          }
          break;
        case 2:
          set_nav_stage(2);
          NextStage();
          nav_goto_block(17);
          break;
        default:
          set_nav_stage(3);
          NextBlock();
          break;
        
      }
      break;
    default:
      tmp_nav_stage = get_nav_stage();
      switch (tmp_nav_stage) {
        case 0:
          set_nav_stage(0);
          nav_home();
          break;
        default:
          set_nav_stage(1);
          NextBlock();
          break;
        
      }
      break;
    
  }
}


#endif // NAV_C

#endif // FLIGHT_PLAN_H
